local data = {}
data.games = {}--beans={}}
local current = data.games.beans

local r
local function loadf(f)
    r = require(f)
end

local loadFile = function(file)
    r = nil
    if pcall(loadf,file) then
        return r
    end
    return nil
end

function loadLevels(path)
    data.levels = data.levels or {}
    current = current or data.games.beans
    current.levels = {}
    if not path then
        local dir = string.format("%s/data/levels",love.filesystem.getWorkingDirectory())
        local dirs = love.filesystem.getDirectoryItems(dir)
        for i = 1,#dirs do
            local file,err = love.filesystem.load(string.format("%s/%s",dir,dirs[i]))()
            if not file then
                error("Problem loading "..dirs[i].." at "..tostring(err))
            end
            data.levels[file.name] = file
            data.levels[dirs[i]:sub(1,-5)] = file
            current.levels[file.name] = file
            current.levels[dirs[i]:sub(1,-5)] = file
            file.parent = current
        end
    end
    
    if path then
        local dirs = love.filesystem.getDirectoryItems(path.."/levels")
        for i = 1,#dirs do
    
            local filedata,err = love.filesystem.load(string.format("%s/levels/%s",path,dirs[i]))()
            if not filedata then
                error("Problem loading "..dirs[i].." at "..tostring(err))
            end
            data.levels[filedata.name] = filedata
            data.levels[dirs[i]:sub(1,-5)] = filedata
            current.levels[filedata.name] = filedata
            current.levels[dirs[i]:sub(1,-5)] = filedata
            filedata.parent = current
        end
        
        
        local dirs = love.filesystem.getDirectoryItems(path.."/images")
        for i = 1,#dirs do
        
            --[[local filedata = love.filesystem.load(string.format("%s/%s",dir,dirs[i]))()
            if not filedata then
                error("Problem loading "..dirs[i])
            end]]
            
            game._sources[dirs[i]] = love.graphics.newImage(path.."/images/"..dirs[i])
        end
        
        local dirs = love.filesystem.getDirectoryItems(path.."/sounds")
        for i = 1,#dirs do
            media.loadFile(path.."/sounds/"..dirs[i],dirs[i])
        end
        
        local dirs = love.filesystem.getDirectoryItems(path.."/music")
        for i = 1,#dirs do
            media.loadMusicFile(path.."/music/"..dirs[i],dirs[i])
        end
    end
end

--loadLevels()

function loadAllData()
    local dirs = love.filesystem.getDirectoryItems("gamedata")
    for i = 1,#dirs do
        data.games[dirs[i]] = {}
        current = data.games[dirs[i]]
        
        current.name = dirs[i]
        
        local path = "gamedata/"..dirs[i]
        local ttype = love.filesystem.getInfo(path).type
        log(ttype)
        if ttype=="directory" then
            loadLevels(path)--dirs[i]) log(dirs[i])
        end
    end
end

loadAllData()

return data