local gooi, class = gooi, class

local winningText = {
    "Feeling energetic...",
    "Feeling tingly...",
    "Getting hyped",
    "Feeling cool"
}
local losingText = {
    "Feeling scared...",
    "Bitter sweet",
    "Who'll read my will?",
    "Feeling nervous"
}
local idleText = {
    "He's weird.",
    "When will I eat dinner",
    "There once was a bear, A BEAR A BEAR",
    "I want to play Super Mario",
}

DialogScreen = class:extend("DialogScreen")

function DialogScreen:__init__(kwargs)
    self.icon = ""--image
    self.name = "Treaty"
    
    self.levelData = nil
    
    self.title = nil
    
    self.lastLoadedInfo = 0
    self.maxLoadInfo = 1
end

function DialogScreen:loadLevel(lvl)
    if type(lvl)=="string" then
        lvl = data.levels[lvl]
    end
    
    self.levelData = lvl
    self.losing, self.winning = false, false
    
    self._iconButton = gooi.newButton({text="Treaty"})
    
    local des = function()
        self.lost = true--:gameover()
    end
    
    local function back(r)
        gooi.confirm({
          text = "Exit meeting?\nare you sure?\nREALLY!?",
          ok = des,
          cancel = null,
          okText = "Of course",
          cancelText = "Never",
          group = "4"
        })
    end
    
    self.inffo = gooi.newButton({text="..."})
    self.title = gooi.newPanel({
        x=0,y=0,
        w=W(),h=H()/7,
        layout="grid 3x4"
    }):
    setColspan(1,2,3):
    setColspan(2,2,3):
    setColspan(3,2,3):
    add(
        self._iconButton,
        gooi.newButton({text=self.levelData.parent.name}),
        gooi.newButton({text="<-"}):onRelease(back),
        self.inffo
    )
    
    self.op1Text = ""
    self.op2Text = ""
    self.op3Text = ""
    self.op4Text = ""
    
    local ff = null
    self.op1Button = gooi.newButton({text=self.op1Text}):
        onRelease(ff)
    self.op2Button = gooi.newButton({text=self.op2Text}):
        onRelease(ff)
    self.op3Button = gooi.newButton({text=self.op3Text}):
        onRelease(ff)
    self.op4Button = gooi.newButton({text=self.op4Text}):
        onRelease(ff)
    
    self.options = gooi.newPanel({
        x=0,y=H()-(H()/7),
        w=W(),h=H()/7,
        layout="grid 2x2"
    }):add(
        self.op1Button,
        self.op2Button,
        self.op3Button,
        self.op4Button
    )
    
    self.lost = false
    self.signed = false
    
    media.loadMusic(self.levelData.music or "tmp", true, nil, nil, self.levelData.musicVolume)
    --love.audio.setVolume(.2)
    self:loadDialog(self.levelData["p1"])

end

function DialogScreen:loadInfo(text,now)
    if self.lastLoadedInfo<=0 or now then
        self.inffo:setText(text)
        self.lastLoadedInfo = self.maxLoadInfo
    end
end

function DialogScreen:loadOption(opt)
    
    local dia = self.levelData[opt]
    assert(dia, opt)
    self:loadDialog(dia)
end

function DialogScreen:loadDialog(opt)
    local function chooseOpt(b)
        self:loadOption(b.data)
    end
    
    self.current = opt
    
    self:setSpeechText(opt.text)
    
    for x = 1,4 do
        local but = self[string.format("op%sButton",x)]
        but:setText("...")
        but:onRelease(null)
    end
    
    local ld = self.levelData
    
    local winning, losing
    
    for x = 1,4 do
        local txt = string.format("op%sText",x)
        local but = self[string.format("op%sButton",x)]
        self[txt] = ""
        if opt[x] then
            self[txt] = opt[x][2]
            but.data = opt[x][1]
            if ld[but.data].SIGNED then
                self:loadInfo(lume.randomchoice(winningText))
                self.winning = true
                winning = true
            elseif ld[but.data].BOOM then
                self:loadInfo(lume.randomchoice(losingText))
                self.losing = true
                losing = true
            elseif self.winning then
                self:loadInfo("Something happened...")
            elseif self.losing then
                self:loadInfo("That was close...")
            else
                self:loadInfo(lume.randomchoice(idleText))
            end
                
            if not losing then
                self.losing = false
            end
            
            if not winning then
                self.winning = false
            end
            
            but:setText(self[txt]):
            onRelease(chooseOpt)
        end
    end
    
    if opt.BOOM then
        self.lost = self.lost or true
        self:loadInfo("Oh, mama's biscuits...", true)
    end
    
    if opt.SIGNED then
        media.sfx.signed:play()
        self.signed = self.signed or true
        self:loadInfo("Oh, yes, yes, yes...", true)
    end
end

--Sets text for talker
function DialogScreen:setSpeechText(text,image)
    Talkies.onAction()
    self.info = Talkies.say(self.levelData.name or "Info", text, {
        backgroundColor = colors.grey,
        image = game:getSource(image or self.levelData.source or "person.png"),
        imageColor = sprite and sprite.color,
        talkSound = media.sfx[self.levelData.textSound or "person_moved"].source,
        pitchValues = self.levelData.pitchValues,
        --messageColor = colors.black,
        --imageOpacity = 1
        textSpeed = self.levelData.textSpeed or 0.05
    })
end

function DialogScreen:drawSky()
    local sky = game:getAsset("sky.png")
    local w,h = resizeImage(sky, W(), H())
    love.graphics.draw(sky,0,0,0,w,h)
end

function DialogScreen:draw()
    self:drawSky()
    gooi.draw()
    Talkies.draw()
    gooi.draw("4")
end

function DialogScreen:update(dt)
    self.lastLoadedInfo = self.lastLoadedInfo-dt
    Talkies.update(dt)
    gooi.update(dt)
end

function DialogScreen:destroy()
    gooi.removeComponent(self.title)
    gooi.removeComponent(self.options)
end

function DialogScreen:create()
    self:destroy()
    gooi.addComponent(self.title)
    gooi.addComponent(self.options)
end

function DialogScreen:mousepressed(id,x,y)
    if Talkies.isComplete() then
        gooi.pressed()
    end
end

function DialogScreen:gameover()
    Talkies.onAction()
    self:destroy()
    game.chooseMenu:create()
    GSS(game.chooseMenu)
end

function DialogScreen:mousereleased(id,x,y)
    if self.lost==1 then
        self:gameover()
    elseif self.lost and Talkies.isComplete()  then
        self:setSpeechText([[The treaty of peace was not signed.
The Earth got destroyed because it could not keep up with the advanced
tech of other alien societies in the universal war.]],"explosion.png")
        self.lost = 1
        media.sfx.boom:play()
    end
    
    if self.signed == 1 then
        self:gameover()
    elseif self.signed and Talkies.isComplete() then
        self:setSpeechText([[
You have managed to get this alien leader pity for your planet.
It signs the treaty of peace]],"star.png")
        self.signed = 1
        media.sfx.signed:play()
    end

    if Talkies.isComplete() then
        gooi.released()
    else
        Talkies.onAction()
    end
    
end-- log=error

function DialogScreen:keypressed(...)
    gooi.keypressed(...)
end

function DialogScreen:keyreleased(...)
    gooi.keyreleased(...)
end

return DialogScreen