local Game  = {}
local load  = load
local data  = data
local lume  = lume
local floor = math.floor
local defaultAction = "function(self) self:nextAction() end"

gooi.desktopMode()
function Game:log(l)
    log(l)
end

function Game:quit()
    love.event.quit()
end

function Game:enter()
    --self.__init__()
end

function Game:getColor(color)
    local col =  self.color[color]
    if not col then
     --   return self.color.black
    end
    return col
end

function Game:reset()
    resetAll()
end

function Game:start()
      --[[splash = Splash:new()
      GSS(splash)
      splash:addSplash(self:getSource("icon.png"),.000001)
      --splash:addSplash(self:getSource("kiventlogo.png"),1.5)
      splash:onComplete(function()
        Gamestate.switch(mainMenu)
      end)]]
      self.chooseMenu = SelectGameMenu:new()
      GSS(self.chooseMenu)--self:startNewGame("pasta")
    
end

function Game:pause()
end

function Game:update(dt)
    portland.updateOrientation(dt)
    local trash = self.room and self.room:update(dt)
    Talkies.update(dt)
    gooi.update(dt)
    if self.room and not self.room.playing and not Talkies.hasDialog() 
    and not self.shaking then
        self.next.enabled = true
    elseif Talkies.hasDialog() then
        self.next.enabled = false
    end
end

function Game:new(o)
    local o = o or {}
    setmetatable(o, self)
    self.__index = self
    return o
end

function Game:startSavedGame()
end

function Game:startNewGame(_data, level)

    local data = _data or data
    local level = level or "bambooz"
    
    gooi.removeComponent(mainMenu.load)
    gooi.removeComponent(mainMenu.menu)
    

   self.points = 0
   self.scene:loadLevel(level)
   GSS(self.scene)
end

function Game:hasSavedGame()
end

function Game:setMenu(menu, viewer)
    local cs = self.currentMenu
    
    
    --self.viewer = viewer or self.viewer
    local menu = (type(stats)=="table" and menu) or (self[menu])
    
    if cs and cs ~= menu then
        cs:destroy()
    end
    
    if viewer then
        
        menu:build(viewer)
    else
    end
    
    self.currentMenu = menu
end

circ = {}
function Game:__init__(debug)
    self._sources = {}
    self._storage = {}
    self.players = {}
    self.events = {}
    self.state = {}
    self._reloadActs = {}
    self.points = 0
    
    self.room = nil
    self.currentPersonIndex = nil

    --[[self._text = gooi.newText({text=""})
    self.debugPanel = gooi.newPanel({layout="grid 1x5",w=W(),h=H()/10,y=0,x=0}):
        setColspan(1,1,4):
        
        add(
            self._text,
            gooi.newButton({text="Submit"}):
            onRelease(function()
                _G["self"] = self
                loadstring(self._text:getText())()
                local s = self
                _G["self"] = nil
                local self = s
                self._text:setText("")
                assert(self._text:getText()=="")
            end)
        )
    self.debugInfo = debug or true
    self.debug = debug or true]]
    self.debugLabel = 
     gooi.newLabel({text = "", x = 50, y = 185, w = 70, h = 10}):left()

     
    self.color = color
    
    --stats viewers
    self.currentMenu = nill
    
    
    self.tmp = {}
    self.setText=function(...) self.debugLabel:setText(...) end

    
    self.drawGooi = true
    
    self.scene = DialogScreen:new()
end

function Game:sayInfo(info,sprite)
    --[[while Talkies.hasDialog() do
        if self.info then
            break
        end
        Talkies.onAction()
    end]]
    
    if type(info) == "string" then
        info = {[""]=info}
    end
    
    local message = ""
    for x, i in pairs(info) do
        if x~="" then
            x = x..": "
        end
        message = message..x..i.."\n"
    end
    
    self.info = Talkies.say("Info", message, {
        backgroundColor = colors.grey,
        image = sprite and sprite.spriteImage,
        imageColor = sprite and sprite.color,
        --messageColor = colors.black,
        --imageOpacity = 1
    })
    
    self.room.dialog = self.info
end

function Game:loadMaps(_path)
    _path = _path or "data/maps"
    for x, i in pairs(data.maps) do
        if type(i) ~= "table" then
            data.maps[x] = love.filesystem.load(_path.."/"..i)()
        end
    end
end

function Game:loadNames()
    local df
    self.maleNames = rot.StringGenerator()
    for x = 1, #self._maleNames do
        df = self._maleNames[x]
        self.maleNames:observe(df)
    end
    
    self.femaleNames = rot.StringGenerator()
    for x = 1, #self._femaleNames do
        df = self._femaleNames[x]
        self.femaleNames:observe(df)
    end
end

function Game:getRandomName(gender)
    local gender = gender or "male"
    local r = self[gender.."Names"]:generate()
    local count = 0
    while not lume.find(self["_"..gender.."Names"],r) and count<500 do
        r = self[gender.."Names"]:generate()
        count = count + 1
    end
    lume.remove(self["_"..gender.."Names"],r)
    return r
end


function Game:loadGoap()
    data.goalList = {}
    self._reloadActs = {}
    local order = {"sub","want","verb","obj"}
    
    for x, i in pairs(data.goals) do
        i.id = i.id or x
        i.order = i.order or order
        i.obj = i.obj or i.last or nil
        i.sub = i.sub or i.first or "I"
        i.verb = i.verb or i.name or ""
        i.want = i.want or "want to"
        table.insert(data.goalList, x)
    end
    
    local actions = Action.new()
    
    for x, i in pairs(data.goap) do
    
        
        for xy,ix in ipairs(lume.copy(i.req)) do
            i.req[ix] = true
            --if not removed glitch in GOAP condition_met happens
            table.remove(i.req, xy)
        end
        for xy, ix in ipairs(lume.copy(i.set)) do
            i.set[ix] = true
            table.remove(i.set, xy)
        end
        
        i._action = i.action or i.act or defaultAction
        i.action = loadString("return "..i._action)
        assert(i.action,i._action)
        
        i.action = i.action()
        
        actions:add_condition(x, i.req)
        actions:add_reaction(x, i.set)
        local f = i.w or i.cost or i.weight
        
        if f == "distance" then
            table.insert(self._reloadActs, {name=x,val=f})
            f = 0
        end
        
        if f then
            actions:set_weight(x, f)
        end
    end
    
    self.actions = actions
    self.currentPosInGoap = 1
end

function Game:reloadActions(obj, target)
    local act
    for i = 1, #self._reloadActs do
        act = self._reloadActs[i]
        local val = act.val
        if val == "distance" then
            val = lume.distance(obj, target)
        end
        self.actions:set_weight(act.name, val)
    end
end
ff=function() self.room:loadTask("leakage") end--????
function Game:loadEvents()
    local dAct = "function() end"
    
    for i,o in pairs(data.tasks) do
        o._action = o.action or o.act or dAct
        o.action = loadString("return "..o._action)
        assert(o.action,o._action)
        o.action = o.action()
    end
    
    for i,o in pairs(data.events) do
        o._action = o.action or o.act or dAct
        o.action = loadString("return "..o._action)
        assert(o.action,o._action)
        o.action = o.action()
    end
end

function Game:startPlay()
    if not self.room.playing and not self.shaking then
        self.room:updateEvents()
        self:nextPerson(1)
    end
end
 
function Game:nextPerson(n)
    local trash = self.room.people[self.currentPersonIndex]
    if trash then
        trash.playing = false--problem
    end
    
    if n then
        self.currentPersonIndex = n-1
    end
    local r = self.currentPersonIndex+1
    if r > #self.room.people then
        r = 1
        self.room.playing = nil
        return
    end
    self.room.playing = self.room.people[r]
    self.room.people[r]:play()
    self.currentPersonIndex = r
end

function Game:buttonPressed()
    self._buttonPressed = true
end

function Game:getSource(source)
    if self._sources[source] == nil then
        self._sources[source] = Graphics.newImage("assets/"..source)--scale later
    end
    return self._sources[source]
end

function Game:getAsset(...)
    return self:getSource(...)
end

function Game:reset()
end


function Game:draw()
    portland.orient()
    local trash = self.room and self.room:draw()
    if self.drawGooi then
        gooi.draw()
    end
    for x, i in ipairs(circ) do
        love.graphics.rectangle("fill",i[1],i[2],10,10)
    end
    local a,b,c,d = love.graphics.getColor()
    love.graphics.setColor(colors.red)
    self.room.camera:attach()
    
    for x, i in ipairs(circ) do
        local ix,iy = i[1],i[2]--self.room.camera:toCameraCoords(i[1],i[2])
   --     love.graphics.rectangle("fill",ix,iy,100,100)
        --self.room:follow(ix,iy)
    end
    --self.room:colorTile(self.room.t,"red")
    self.room.camera:detach()
    love.graphics.setColor(a,b,c,d)
        love.graphics.print("FPS: "..love.timer.getFPS(),100, H()-100,0,2,2)
        love.graphics.print(collectgarbage("count")/1024,100, H()-50,0,2,2)
        love.graphics.print(self.points,100, H(),0,2,2)
    Talkies.draw()
end

function Game:mousereleased(x, y, button) 
    if self.drawGooi then
        gooi.released()
    end
    local trash = self.room and self.room:mousereleased(x,y)
end

function Game:mousepressed(x, y, button)
    x,y = love.mouse.getPosition()
    if self.drawGooi then
        gooi.pressed()
    end
    local trash = self.room and self.room:mousepressed(x,y)
    
    if self._buttonPressed then
        ttx = x
        tty = y
        self._buttonPressed = false
        return
    end
    
    self._buttonPressed = false
    local x, y = self.room:convertToTile(self.room.camera:toWorldCoords(x,y))
    local tile = self.room:getTile(floor(x),floor(y))
    if tile then
        local unit = tile.unit
        if unit then
            self.room.camera:follow(unit)
            if unit.isPerson then
                if self.room.viewer and self.room.viewer~=unit then
                    log(self.room.viewer.views[unit.name])
                    self.esv:build(unit)
                    
                else
                    log("trying")
                    self.psv:build(unit)
                end
            end
        else
            local trash = (self[self.currentMenu] or self.psv):destroy()
        end
    else
        local trash = (self[self.currentMenu] or self.psv):destroy()
    end
    Talkies.onAction()
    
end

function Game:touchreleased(id, x, y, dx, dy, pressure)
end

function Game:textinput(text)
  gooi.textinput(text)
end

function Game:keypressed(key, scancode, isrepeat)
  gooi.keypressed(key, scancode, isrepeat)
  if key == "escape" then
    p:close()
    love.event.quit()
  end
end

function Game:keyreleased(key, scancode)
  gooi.keyreleased(key, scancode)
end


--stores an object by its id
function Game:store(object)
    self._storage[tostring(object)] = object
end

--gets an object by its id
function Game:get(object)
    local id = (type(object) ~= "table" and object) or tostring(object)
    local obj = self._storage[id]
    if not obj then
        warn("Object "..tostring(object).." of type "..type(object).." not found")
        return false
    end
    return obj
end

function Game:loadLua(code)
    local func = load(code)
    return func()
end

return Game