EmotionalStats = class:extend("EmotionalStats")

function EmotionalStats:__init__(kwargs)
    local kwargs = kwargs or {}
end

function EmotionalStats:build(unit)
    self.destroyed = false
    self.unit = unit
    self.map = unit.map
    local map = self.map
    local viewer = map.viewer
    assert(viewer)
    local emos = viewer.views[unit.name]
    
    local function open(view)
        game:setMenu("psv",view or viewer)
    end
    self.open = open
    local function exit()
        self:destroy()
    end
    
    gooi.removeComponent(self.viewer)
    
    local function changeVal(val,n)
        if val > 0 and game.points < 1 then
            return false
        end
        
        if val < 0 then
            game.points = game.points+1
        else
            game.points = game.points-1
        end
        
        
        if n == self.happySpinner then
            emos.happiness = emos.happiness+val
        elseif n == self.kindSpinner then
            emos.kindness = emos.kindness+val
        elseif n == self.braveSpinner then
            emos.bravery = emos.bravery+val
        end
    end
    

    self.name = gooi.newButton({text="<-"..unit.name}):onRelease(exit)
    
    self.happySpinner = gooi.newSpinner({min=0,max=10,value=0,sense=10}):onValue(changeVal)
    self.kindSpinner = gooi.newSpinner({min=0,max=10,value=0}):onValue(changeVal)
    self.braveSpinner = gooi.newSpinner({min=0,max=10,value=0}):onValue(changeVal)
    
    local hT = (viewer:isHappy(unit) and "happy around") or "angry around"
    local kT = (viewer:isKind(unit) and "kind to") or "mean to"
    if kT=="kind to" and viewer.views[unit.name].kindness<5 then error() end
    local bT = (viewer:isBrave(unit) and "brave around") or "scared around"
    
    local cam = unit.map.camera
    local sc = .5
    local h = (H()*.5)*sc
    local w = (W()*.5)*sc
    
    x,y= unit.map.camera:toCameraCoords(unit.x+unit.w*2,unit.y-h/2)
    self.viewer = gooi.newPanel({
        w=w, h=h,
        x=x,y=y,
        layout="grid 8x1"
    }):
    add(
        self.name,
        gooi.newButton({text=hT}),
        self.happySpinner,
        gooi.newButton({text=kT}),
        self.kindSpinner,
        gooi.newButton({text=bT}),
        self.braveSpinner

    )
    self.happySpinner.value = emos.happiness
    self.kindSpinner.value = emos.kindness
    self.braveSpinner.value = emos.bravery
    
    self.viewer:rebuild()
    self.viewer.layout:init(self.viewer)
    game:setMenu("esv")
    gooi.addComponent(self.viewer)
    media.popUp:play()
    
end

function EmotionalStats:destroy()
    if self.destroyed then
        return
    end
    self.destroyed = true
    
    if self.map then
        self.map.unit = nil
        self.open(self.map.viewer)
    end
    
    gooi.removeComponent(self.viewer)
    self.unit = nil
end

return EmotionalStats