PhysicalStats = class:extend("PhysicalStats")
local log = tostring
function PhysicalStats:__init__(kwargs)
    local kwargs = kwargs or {}
    

end

function PhysicalStats:build(unit)
    self.destroyed = false
    
    self.unit = unit
    self.map = unit.map
    local function exit()
        self:destroy()
    end
    
    gooi.removeComponent(self.viewer)
    
    local function changeVal(val,n)
        if val > 0 and game.points < 1 then
            return false
        end
        
        if val < 0 then
            game.points = game.points+1
        else
            game.points = game.points-1
        end
        log(tostring(self.unit).." unit")
        
        if n == self.healthSpinner then
            self.unit.stats.health = self.unit.stats.health+val*10
        elseif n == self.warmthSpinner then
            self.unit.stats.warmth = self.unit.stats.warmth+val
        elseif n == self.strengthSpinner then
            self.unit.stats.strength = self.unit.stats.strength+val
        end
        return true
    end
    
    local function viewOther()
        exit()
        unit.map.viewer = unit
    end

    self.name = gooi.newButton({text="<- "..unit.name}):onRelease(exit)
    --self.goal = gooi.newButton({text=unit:getGoalDescription()})
    game:sayInfo({[unit.name.."'s goal"]=unit:getGoalDescription()},unit)

    self.healthSpinner = gooi.newSpinner({min=0,max=100,value=0,sense=10}):onValue(changeVal)
    self.warmthSpinner = gooi.newSpinner({min=0,max=10,value=0}):onValue(changeVal)
    self.strengthSpinner = gooi.newSpinner({min=0,max=10,value=0}):onValue(changeVal)

    self.viewOther = gooi.newButton({text="View Other"}):onRelease(viewOther)
    
    local cam = unit.map.camera
    local sc = .5
    local h = (H()*.5)*sc
    local w = (W()*.5)*sc
    
    x,y= unit.map.camera:toCameraCoords(unit.x+unit.w*2,unit.y-h/2)
    self.viewer = gooi.newPanel({
        w=w, h=h,
        x=x,y=y,
        layout="grid 8x1"
    }):
    add(
        self.name,
      --  self.goal,
        gooi.newButton({text="Health"}),
        self.healthSpinner,
        gooi.newButton({text="Warmth"}),
        self.warmthSpinner,
        gooi.newButton({text="Strength"}),
        self.strengthSpinner,
        self.viewOther
    )
    self.healthSpinner.value = unit.stats.health
    self.warmthSpinner.value = unit.stats.warmth
    self.strengthSpinner.value = unit.stats.strength
 --   self.viewer.x, self.viewer.y = unit.map.camera:toWorldCoords() --self.viewer.x=10000
    self.viewer:rebuild()
    self.viewer.layout:init(self.viewer)
     log(tostring(self.unit).." unit")
    game:setMenu("psv")
    gooi.addComponent(self.viewer)
    media.popUp:play()
    
end

function PhysicalStats:destroy()
    if self.destroyed then
        return
    end
    self.destroyed = true
    
    log("destroybig")
    gooi.removeComponent(self.viewer)
    self.unit = nil
    if self.map then
        self.map.unit = nil
        self.map.viewer = nil
    end
end

return PhysicalStats