local Graph = class:extend("Graph")
local table = table

function Graph:__init__(numSamples)
    --local self = setmetatable({}, { __index = Graph })
    self.samples = {}
    self.title = "fps"
    if type(numSamples) == "string" then
        self.itle = numSamples
        numSamples = nil
    end
    for i = 1, numSamples or 300 do
        self.samples[i] = 0
    end
    return self
end

function Graph:draw(x, y, xSize, ySize, r, g, b)
    love.graphics.push('all')
    love.graphics.setColor(r or 1, g or 1, b or 1)
    love.graphics.translate(x or 0, y or 0)
    love.graphics.scale(xSize or 30, ySize or xSize or 30)
    local samples = self.samples
    local max, min = math.max(unpack(self.samples)), math.min(unpack(self.samples)) - 5
    local yScale = max - min == 0 and 1 or 1 / (max - min)
    for i = 2, #samples do
        love.graphics.polygon(
            'fill',
            (i - 1) / #samples, 1 - yScale * (samples[i - 1] - min),
            i / #samples, 1 - yScale * (samples[i] - min),
            i / #samples, 1,
            (i - 1) / #samples, 1)
    end
    love.graphics.pop()
    --love.graphics.print('fps:  ' .. love.timer.getFPS(),
   love.graphics.print(self.title..":  "..self.samples[#self.samples],x or 0, (y or 0)-((ySize or xSize or 30)/2))
end

function Graph:sample(s)
    table.remove(self.samples, 1)
    table.insert(self.samples, s)
end

return Graph