local LifeBar = class:extend("LifeBar")

function LifeBar:__init__(kwargs)
    self.parent = kwargs.parent or kwargs
    self.totalHealth = kwargs.totalHealth or self.parent.totalHealth
    self.x = kwargs.x or 0
    self.y = kwargs.y or 0
    self.w = kwargs.w or 40
    self.h = kwargs.h or 4
    
    self.damagedColor = getColor(kwargs.damagedColor or "red")
    self.healthColor = getColor(kwargs.healthColor or "green")
    
    self.alwaysDraw = kwargs.alwaysDisplay or kwargs.alwaysDraw
end

function LifeBar:getHealth()
    local h = self.parent.life or self.parent.health or 100
    if h<=0 then
        return 0
    end
    return h
end

function LifeBar:getTotalHealth()
    return self.totalHealth or self.parent.totalHealth or self.parent.totalLife or 100
end

function LifeBar:draw()
    local h = self:getHealth()
    local t = self:getTotalHealth()
    if h/t >= 1 and not self.alwaysDraw then
        return
    end
    
    local r,g,b, a = love.graphics.getColor()
    
    love.graphics.setColor(self.damagedColor)
    love.graphics.rectangle('fill', self.x, self.y, self.w, self.h)
    love.graphics.setColor(self.healthColor)
    love.graphics.rectangle('fill', self.x, self.y, h / t * self.w, self.h)
        
    love.graphics.setColor(r,g,b,a)
end

return LifeBar